Create a standalone invoice
Creates a standalone invoice for selling physical goods, services or other items on a non-recurring basis to your subscription customers.
To use this operation, you must have the Modify Invoice and at least one of the Create Standalone Invoice With Product Catalog or Create Standalone Invoice Without Product Catalog user permissions. See Billing Roles for more information.
Authentication
Use Bearer {{token}} in the Authorization header for authentication.
Headers
Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.
If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.
Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.
The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').
An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.
The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.
The minor API version.
For a list of available minor versions, see API upgrades.
Request
The date that appears on the invoice being created, in yyyy-mm-dd format. The value cannot fall in a closed accounting period.
The ID of the account associated with the invoice.
You must specify either accountNumber or accountId for a customer account. If both of them are specified, they must refer to the same customer account.
The Number of the account associated with the invoice.
You must specify either accountNumber or accountId for a customer account. If both of them are specified, they must refer to the same customer account.
Container for bill-to, sold-to, or ship-to contact information. A new Contact will be created under the invoice owner account.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
The ID of the bill-to contact associated with the invoice. This field is mutually exclusive with the billToContact field.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
The code of a currency as defined in Billing Settings through the Zuora UI.
If you do not specify a currency during standalone invoice creation, the default account currency is applied. The currency that you specify in the request must be configured and activated in Billing Settings. Note: This field is available only if you have the Multiple Currencies feature enabled.
It contains Home currency and Reporting currency custom rates currencies. The maximum number of items is 2 (you can pass the Home currency item or Reporting currency item or both).
Note:
- This field is available only if you are on the latest Zuora API minor version, or you set the
Zuora-Versionrequest header to224.0or a later available version. - You cannot set the custom rates, if both the Automatically include additional Currency Conversion information in data source exports option and Fx data feature are enabled.
- Invoice, InvoiceItem, and TaxationItem will utilize the provided custom Fx rate to convert amounts from the transactional currency to the home currency.
The date by which the payment for this invoice is due, in yyyy-mm-dd format.
Container for invoice items. The maximum number of invoice items is 1,000.
You must have corresponding billing permissions to create invoice items from existing product rate plan charges or new charges. For more information about billing permissions, see Billing Roles.
- To create an invoice item from an existing charge, you must have the Create Standalone Invoice With Product Catalog permission and specify the charge ID in the
productRatePlanChargeIdfield. - To create an invoice item from a new charge, you must have the Create Standalone Invoice Without Product Catalog permission without specifying the
productRatePlanChargeIdfield.
Note: For the “Create a standalone invoice” and “Create standalone invoices” operations, note the following:
- If tax has been calculated by an external tax engine, you need to create a standalone invoice with both
invoiceItemsandtaxItems. ThetaxItemscorresponds to the tax information processed by this external tax engine. In this case, you should not specify thetaxModeandtaxCodenested fields of theinvoiceItemsfield. Instead, you need to specify thetaxModeandtaxCodenested fields of thetaxItemsfield. You need to specify thetaxModefield asTaxExclusive. - If tax has not been calculated by an external tax engine, you can create a standalone invoice only with
invoiceItems, and decide whether Zuora includes the tax in the quoted charge price and invoice item by specifying thetaxModenested field of theinvoiceItemsfield as eitherTaxExclusiveorTaxInclusive. Meanwhile, you need to specify thetaxCodefield, indicating the charge price and invoice item are taxable.
A customized invoice number with the following format requirements:
- Max length: 32 characters
- Acceptable characters: a-z,A-Z,0-9,-,_,
Purely numerical prefixes or prefixes ending with a number are supported for standalone invoices. For example, you can use 202310000300, 2003, INV202310000300, or 2023-09-100009785 as invoice numbers.
The value must be unique in the system, otherwise it may cause issues with bill runs and subscribe/amend. Check out things to note and troubleshooting steps.
The ID or name of the payment term associated with the invoice. For example, Net 30. The payment term determines the due dates of invoices.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
The ID or name of the sequence set associated with the invoice.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
Container for bill-to, sold-to, or ship-to contact information. A new Contact will be created under the invoice owner account.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
The ID of the ship-to contact associated with the invoice. This field is mutually exclusive with the shipToContact field.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
Whether the ship-to contact and bill-to contact are the same entity. This field is mutually exclusive with the shipToContact and shipToContactId fields.
The created invoice has the same bill-to contact and ship-to contact entity only when all the following conditions are met in the request body:
- This field is set to
true. - A bill-to contact or bill-to contact ID is specified.
- Neither ship-to contact nor ship-to contact ID is specified.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
Container for bill-to, sold-to, or ship-to contact information. A new Contact will be created under the invoice owner account.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
The ID of the sold-to contact associated with the invoice. This field is mutually exclusive with the soldToContact field.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
Whether the sold-to contact and bill-to contact are the same entity. This field is mutually exclusive with the soldToContact and soldToContactId fields.
The created invoice has the same bill-to contact and sold-to contact entity only when all the following conditions are met in the request body:
- This field is set to
true. - A bill-to contact or bill-to contact ID is specified.
- Neither sold-to contact nor sold-to contact ID is specified.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
The status of invoice. By default, the invoice status is Draft.
When creating an invoice, if you set this field to Posted, the invoice is created and posted directly.
The ID of the invoice template associated with the invoice.
Note: If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body.
ID of the corresponding object in NetSuite. Only available if you have installed the Zuora Connector for NetSuite.
Status of the invoice’s synchronization with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.
Date when the invoice was synchronized with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.
Response headers
This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
application/jsonapplication/xmltext/htmltext/csvtext/plain
The request limit quota for the time window closest to exhaustion. See rate limits for more information.
The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.
The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.
The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.
For more information, see Concurrent request limits.
The total number of the permitted concurrent requests.
For more information, see Concurrent request limits.
The remaining number of the permitted concurrent requests.
For more information, see Concurrent request limits.
Response
The ID of the bill-to contact associated with the invoice.
The ID of the bill-to contact snapshot associated with the invoice.
The date and time when the invoice was created, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-01 15:31:10.
The currency amount of the adjustment applied to the customer’s credit balance.
Note: This field is only available if you have the Credit Balance feature enabled and the Invoice Settlement feature disabled.
The currency amount of all credit memos applied to this invoice.
Note: This field is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.
The currency of the invoice.
Note: By default, the currency on a billing document matches the default currency set on the associated account. However, Zuora now offers a Multiple Currencies feature to support different currencies for billing documents, allowing flexibility beyond the account-level currency. For more information, see Multiple Currency.
The date by which the payment for this invoice is due, in yyyy-mm-dd format.
The error code when status is “Failed”. This code can either be a Zuora-generated error code or one returned by a third-party e-invoice vendor.
The error message when status is “Failed”. This message can either be a Zuora-generated error code or one returned by a third-party e-invoice vendor.
The ID of the e-invoice file.
The status of the e-invoice file generation for the invoice.
- If e-invoicing file generation succeeds, this field is either
GeneratedorSuccess, and both the error code and message are empty, and theeInvoiceFieldfieldstores the ID of the generated e-inoice file. - If the responses from tax vendors such as Sovos or Avalara are taking too long, this field becomes
RetrieveTimeOut. Once the vendor responds successfully, you can use the ‘Resync E-Invoice Status’ action to update the status automatically. You can view these updates in System Health telemetry. - If a failure occurs during e-invoice file generation, this field is
Failedand error code and an error message are returned respectively in theeinvoiceErrorCodeandeinvoiceErrorMessagefields. - If e-invoice file generation conditionally succeeds, this field is
ConditionalSuccessand an error code and an error message are returned respectively in theeinvoiceErrorCodeandeinvoiceErrorMessagefields. - If the e-invoice file has been approved by the tax authority, this field is
ApprovedByAuthority. The next status will be eitherSuccessorRejected. - If the e-invoice file has been rejected by the government, this field is
Rejected. You cannot resend this e-invoice; you must create a new invoice instead. Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled.
Specifies whether the invoice includes one-time charges.
The number of the invoice group associated with the invoice.
The value of this field is null if you have the Flexible Billing Attributes feature disabled.
The organization that this object belongs to.
Note: This field is available only when the Multi-Org feature is enabled.
The ID of the ship-to contact associated with the invoice.
The ID of the ship-to contact snapshot associated with the invoice.
The ID of the sold-to contact associated with the invoice.
The ID of the sold-to contact snapshot associated with the invoice.
The ID of the invoice source.
If an invoice is generated from a bill run, the value is the number of the corresponding bill run.Otherwise, the value is null.
Returns true if the request was processed successfully.
The status that the tax engine return after it calculates the taxes of this invoice.
Note: This field is only applicable to tax calculation by third-party tax engines. The Voided status indicates that the tax transaction is successfully canceled on the tax vendor’s side. If a tax transaction was successfully committed to the third-party tax engine but the invoice failed to post, Zuora automatically detects the issue and voids the tax transaction on the vendor’s side.
The ID of the invoice template.
- If you have the Flexible Billing Attributes feature enabled, the value of this field depends on the configuration of the invoice template.
- If you specify an invoice template at the subscription level, the value of this field is automatically populated from the corresponding subscription.
- If you do not specify any invoice template at the subscription level, the value of this field is automatically populated from the corresponding account.
- If you have the Flexible Billing Attributes feature disabled, the value of this field is
null.
ID of the corresponding object in NetSuite. Only available if you have installed the Zuora Connector for NetSuite.
Status of the invoice’s synchronization with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.
Date when the invoice was synchronized with NetSuite. Only available if you have installed the Zuora Connector for NetSuite.